<jnt-stack [orientation]="style === ui.menu.style.tabs ? ui.orientation.horizontal : orientation"
           [gutter]="spacing"
           [align]="ui.align.stretch"
           [wrap]="wrap">
  <ng-container *ngFor="let item of items">
    <div data-top>
      <div data-item [attr.data-active]="item.opened && orientation === ui.orientation.vertical"
                      (click)="!item.disabled ? toggle(item) : null"
           [jntPopover]="{
              context: this.context,
              contentTemplate: submenuPopoverTemplate,
              position: orientation === ui.orientation.vertical
                ? ui.position.right
                : ui.position.bottom,
              trigger: orientation === ui.orientation.horizontal || !collapsed
                ? ui.trigger.click
                : ui.trigger.hover,
              behaviour: ui.behaviour.dropdown,
              placement: placement,
              disabled: item.disabled || !item.submenu || (!collapsed && orientation !== ui.orientation.horizontal)
            }"
           (attached)="reference.popover = $event"
           (removed)="reference.popover = null">
        <div *ngIf="item.loading" data-spinner>
          <jnt-spinner></jnt-spinner>
        </div>
        <jnt-link data-link
                  [collapsed]="collapsed"
                  [opened]="item.opened && orientation === ui.orientation.vertical"
                  [title]="!collapsed ? item.title : null"
                  [icon]="item.icon"
                  [active]="item.active"
                  [context]="style === ui.menu.style.tabs ? ui.context.menu : ui.context.box"
                  [matching]="item.matching"
                  [source]="item.link"
                  [fragment]="item.fragment"
                  [queryParams]="item.queryParams"
                  [outline]="ui.outline.transparent"
                  [target]="item.target"
                  [disabled]="item.disabled"
                  [features]="!!item.submenu ? [ui.feature.dropdown] : null"
                  (click)="item.click.emit(); !item.submenu ? selected.emit(item) : null">
            <jnt-badge *ngFor="let badge of item.badges"
                       [value]="badge.value"
                       [text]="badge.text"
                       [position]="badge.position"
                       [color]="badge.color">
            </jnt-badge>
        </jnt-link>
      </div>

      <ng-container *ngIf="!collapsed && orientation === ui.orientation.vertical">
        <div data-sub-animate *ngIf="item.opened" [@collapse]="item.opened">
          <ng-container *ngTemplateOutlet="submenuTemplate;context: {features: []}"></ng-container>
        </div>
      </ng-container>

      <ng-template #submenuPopoverTemplate>
        <ng-container *ngTemplateOutlet="submenuTemplate;context: {features: item.submenu.features}"></ng-container>
      </ng-template>

      <ng-template #submenuTemplate let-features=features>
        <div data-sub
             [attr.data-opened]="item.opened"
             [attr.data-orientation]="orientation"
             [attr.data-collapsed]="collapsed">
          <ng-container *ngIf="!!item.submenu">
            <div data-section *ngIf="features | includes : ui.feature.title">
              <jnt-stack [orientation]="ui.orientation.horizontal" [align]="ui.align.center">
                <span>{{item.title}}</span>
                <jnt-badge *ngFor="let badge of item.badges"
                           [value]="badge.value"
                           [text]="badge.text"
                           [position]="ui.position.inline"
                           [color]="badge.color">
                </jnt-badge>
              </jnt-stack>
            </div>
            <div data-item *ngFor="let subItem of item.submenu.items">
              <div *ngIf="subItem.loading" data-spinner>
                <jnt-spinner></jnt-spinner>
              </div>
              <jnt-link data-link
                        [context]="ui.context.box"
                        [title]="subItem.title"
                        [icon]="subItem.icon"
                        [active]="subItem.active"
                        [matching]="subItem.matching"
                        [source]="subItem.link"
                        [fragment]="subItem.fragment"
                        [queryParams]="subItem.queryParams"
                        [disabled]="subItem.disabled"
                        [target]="subItem.target"
                        (click)="selected.emit(subItem); subItem.click.emit(); reference.popover?.hide();">
                <jnt-badge *ngFor="let badge of subItem.badges"
                           [value]="badge.value"
                           [text]="badge.text"
                           [position]="ui.position.inline"
                           [color]="badge.color">
                </jnt-badge>
              </jnt-link>
            </div>
          </ng-container>
        </div>
      </ng-template>
    </div>
  </ng-container>
</jnt-stack>
